<?php

namespace Drupal\images_optimizer\Optimizer;

use Drupal\file\FileInterface;

/**
 * Interface for the optimizers.
 *
 * @package Drupal\images_optimizer\Optimizer
 */
interface OptimizerInterface {

  /**
   * Optimize the image.
   *
   * @param string $image_path
   *   The absolute image path.
   * @param \Drupal\file\FileInterface $image
   *   The image file instance.
   *
   * @return bool
   *   TRUE if the optimization was successful, FALSE otherwise.
   */
  public function optimize($image_path, FileInterface $image);

  /**
   * Get the mime types supported by this optimizer.
   *
   * @return string[]
   *   An array of mime types.
   */
  public function getSupportedMimeTypes();

}
